% POST PROCESSING ROUTINE FOR SPHYSICSgen_3D. THIS PROGRAM PLOTS THE INITIAL
% PARTICLE CONFIGURATION USING IPART. 
% THIS PROGRAM SEARCHES FOR THE IPART, DT AND matlabin FILES IN THE 
% CURRENT MATLAB WORKING DIRECTORY. 

clear all
close all
%READ PARAMETERS FROM MATLABIN
load matlabin;
np=matlabin(1)
vlx=matlabin(2)
vly=matlabin(3)
vlz=matlabin(4)
out=matlabin(5)
nb=matlabin(6)
nbf=matlabin(7)

%SET Nframes=0 TO PLOT INITIAL CONFIGUTATION. DEPENDING ON WHETHER A 2D OR
%3D VIEW IS CHOSEN THIS IS USED IN THE PROGRAMS
%MovingObjects2D, NoMovingObjects2D or MovingObjects3D, NoMovingObjects3D
Nframes=0;

%INITIALIZE PARTICLE SIZE, PLOT AXES AND
%POSITION OF TEXT
ParticleSize=12;
xmin=-0.01;
xmax=1.5*vlx;
ymin=-0.01;
ymax=1.5*vly;
zmin=-0.01;
zmax=1.5*vlz;

%CHOOSE IF 3D VIEW IS DESIRED OR SIDE VIEW(x-z PLANE) IS DESIRED
iview=input('Enter 0 for 3D view or\n Enter 1 for sideview(X-Z plane) or \n Enter 2 for frontview(Y-Z plane)or \n Enter 3 for topview(X-Y plane) \n ')

%IF A 2D VIEW IS CHOSEN THEN INITIALIZE THE FOLLOWING VARIABLES USED BY
%MovingObjects2D AND NoMovingObjects2D TO DECIDE WHICH 2 COLUMNS OF THE
%PART_ijkl FILES WILL BE PLOTTED.
if(iview==1)
    ix=1;
    iy=3;
    minx=xmin;
    maxx=xmax;
    miny=zmin;
    maxy=zmax;
    labelx='X(m)';
    labely='Z(m)';
elseif(iview==2)
    ix=2;
    iy=3;
    minx=ymin;
    maxx=ymax;
    miny=zmin;
    maxy=zmax;
    labelx='Y(m)';
    labely='Z(m)';
elseif(iview==3)
    ix=1;
    iy=2;
    minx=xmin;
    maxx=xmax;
    miny=ymin;
    maxy=ymax;
    labelx='X(m)';
    labely='Y(m)';
end

%INITIALIZE FIGURE AND SET PROPERTIES
XF=figure;
set(XF,'DefaultAxesFontSize',12)
set(XF,'DefaultTextFontSize',12)

%SET NORMALIZED FIGURE POSITION AND SIZE TO MAKE IT CONSISTENT OVER ALL
%MONITORS
set(XF,'Units','normalized')
set(gcf,'Position',[0.1,0.5,0.9,0.5])

% IF THE SIMULATION HAS FIXED BOUNDARIES CALL NoMovingObjects ELSE
% CALL MovingObjects. VARIABLE nbf IS THE NUMBER OF FIXED BOUNDARY
% PARTICLES
if(iview==0)
    if(nbf<nb) 
        MovingObjects3D
    else
        NoMovingObjects3D
    end
else
    if(nbf<nb) 
        MovingObjects2D
    else
        NoMovingObjects2D
    end
end  
