c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

       subroutine check_limits_3D
       include 'common.3D'
       
       double precision dyp_dble
       double precision ymin_container_double, ymax_container_double
       
       zmax=0
       ncases=0
       
       do i=nbp1,np ! Check if any fluid particle is over the box
          if(zp(i).gt.zmax) zmax=zp(i)
          if(iflag(i).eq.1)then
            if(xp(i).gt.xmax_container.or.xp(i).lt.xmin_container.or.
     +         zp(i).lt.zmin_container) then   
              iflag(i)=0
              ncases=ncases+1
              xp(i)=xtrash
              yp(i)=ytrash
              zp(i)=ztrash
              up(i)=0.
              vp(i)=0.
              wp(i)=0.
              um1(i)=0.
              uo(i)=0.
              vm1(i)=0.
              vo(i)=0.
              wm1(i)=0.
              wo(i)=0.
            else if(yp(i).gt.ymax_container.or.
     &              yp(i).lt.ymin_container)then
              if(i_periodicOBs(2).eq.1)then  !Replace Particle on other side of domain
                if(yp(i).gt.ymax_container)then
                  dyp_dble = dble(yp(i)) - ymax_container_double 
                  yp(i) = real(dyp_dble +ymin_container_double)
                else if(yp(i).lt.ymin_container)then
                  dyp_dble = ymin_container_double - dble(yp(i))   
                  yp(i) = real(ymax_container_double - dyp_dble)
                end if
              else
                iflag(i)=0
                ncases=ncases+1
                xp(i)=xtrash
                yp(i)=ytrash
                zp(i)=ztrash
                up(i)=0.
                vp(i)=0.
                wp(i)=0.
                um1(i)=0.
                uo(i)=0.
                vm1(i)=0.
                vo(i)=0.
                wm1(i)=0.
                wo(i)=0.
              end if
            end if
                
         endif   
       enddo
       
       nn=nint((zmax-zmax_ini)*one_over_2h)
       
       if (nn.gt.0) then	    
          zmax = zmax_ini + 2*h*nn
          ncz = int( (zmax-zmin)*one_over_2h ) + 1
          nct = nsheet*ncz !3D
              do i=nct_ini+1,nct
                 nc(i,1)  = 0 !No Boundary Particles in these cells
              enddo
       else
         zmax=zmax_ini
       endif	
       
       
       if (ncases.ne.0) write(*,*) 'Number ',ncases,' time',time
       
       
       return
       
       end